| ECC1C 145-944-00

Public Member Functions | Public Attributes | List of all members
PID::PIDengine

## Public Member Functions
float | computeStep (const float OF_setpoint, const float OF_current)

## Public Attributes
int | ch_num
bool | adaptive_PID_enabled
float | Kp
float | Ki
float | Kd
float | min_output
float | max_output
float | min_integral
float | max_integral
float | Ap
float | Bp
float | Cp
float | Ai
float | Bi
float | Ci
float | Ad
float | Bd
float | Cd
int | sample_rate
float | d_filter_cutoff
float | integral

## Detailed Description

The PID for one value only

## Member Function Documentation

## ◆ computeStep()

float computeStep | ( | const float | OF_setpoint,
|  | const float | OF_current
| ) |  |

Compute a step of PID loop.

References Ad, adaptive_PID_enabled, Ai, Ap, Bi, Bp, Cd, Ci, Cp, integral, Kd, Ki, Kp, max_output, min_integral, and min_output.

## Member Data Documentation

## ◆ Ad

float Ad

Multiplier of the quadratic term of the derivative gain scheduling function

Referenced by computeStep().

## ◆ adaptive_PID_enabled

bool adaptive_PID_enabled

Adaptive PID enable/disable flag

Referenced by computeStep().

## ◆ Ai

float Ai

Multiplier of the quadratic term of the integral gain scheduling function

Referenced by computeStep().

## ◆ Ap

float Ap

Multiplier of the quadratic term of the proportional gain scheduling function

Referenced by computeStep().

## ◆ Bd

float Bd

Multiplier of the linear term of the derivative gain scheduling function

## ◆ Bi

float Bi

Multiplier of the linear term of the integral gain scheduling function

Referenced by computeStep().

## ◆ Bp

float Bp

Multiplier of the linear term of the proportional gain scheduling function

Referenced by computeStep().

## ◆ Cd

float Cd

Constant term of the derivative gain scheduling function

Referenced by computeStep().

## ◆ ch_num

int ch_num

Signal flow channel identifier

## ◆ Ci

float Ci

Constant term of the integral gain scheduling function

Referenced by computeStep().

## ◆ Cp

float Cp

Constant term of the proportional gain scheduling function

Referenced by computeStep().

## ◆ d_filter_cutoff

float d_filter_cutoff

Cut-off frequency of the filter applied on the derivative term

## ◆ integral

float integral

The integral residue

Referenced by computeStep().

## ◆ Kd

float Kd

The coefficient for the PID: Derivative term

Referenced by computeStep().

## ◆ Ki

float Ki

The coefficient for the PID: Integral term

Referenced by computeStep().

## ◆ Kp

float Kp

The coefficient for the PID: Proportional term

Referenced by computeStep().

## ◆ max_integral

float max_integral

The max range for the integral term

## ◆ max_output

float max_output

Max range for the calculated output

Referenced by computeStep().

## ◆ min_integral

float min_integral

The min range for the integral term

Referenced by computeStep().

## ◆ min_output

float min_output

Min range for the calculated output

Referenced by computeStep().

## ◆ sample_rate

int sample_rate

Sampling rate of the PID loop. Parameter is used to initialise the Butterworth filter on the derivative term